#include <unistd.h>

#include <time.h>
#include <SDL/SDL.h>
#include "SDL/SDL_ttf.h"
#include "SDL/SDL_image.h"
#include "SDL/SDL_mixer.h"

#include "main.h"
#include "xgrafi.h"
#include "objetos.h"


void Repaint(void);
void MiTimer();
#define TIEMPO1		10
#define TIEMPO2		80
#define TIEMPO3		50
int tiempo1=TIEMPO1,tiempo2=TIEMPO2, tiempo3=TIEMPO3;
int mouse_x,mouse_y;
int pantaX=480,pantaY=180;
int Fquit = 0;

int segundos=0;

#include "entorno.h"

struct tm *fecha;
time_t ahora;
char cadenaTmp[20];


#include "math.h"
int relojX=370,relojY=90;
int gradosS,gradosM,gradosH;





int main (int argc, char *argv[])
{		
	int SimbolKey;
	//Uint8 *teclas; 
			
	if(init(pantaX,pantaY) == 0 ) return 1;	
	SDL_FillRect( screen, NULL, SDL_MapRGB( screen->format, 0x15, 0xaa, 0x30 ) );
	if( SDL_Flip( screen ) == -1 ) return 3;
	//if (load_files((char*)"modelo2.png",NULL,(char*)"seta.ttf") == 0 ) return 2;
	if (load_files((char*)"reloj.jpg",NULL,(char*)"setam.ttf") == 0 ) return 2;

//_______________________	

	Creacion();
	Repaint();	
//________________________		


	while( Fquit == 0 )
	{	
		SDL_Delay(19);	  
		MiTimer();								  	  
		while( SDL_PollEvent( &event ) )
		{
			//teclas = SDL_GetKeyState(NULL);
			
			switch (event.type)			
			{				
				case	SDL_KEYDOWN:
						SimbolKey=event.key.keysym.sym;
						
						#ifdef DEBUG 
							printf("Evento Tecla SimbolKey=%d \n",SimbolKey);
						#endif										
						switch (SimbolKey)			
							{				
								case	SDLK_F1:
										#if YesWindows
											screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP,SDL_FULLSCREEN | SDL_SWSURFACE );
										#else
											SDL_WM_ToggleFullScreen(screen);
										#endif  
										Repaint();						
								break;
								case	SDLK_F2:
										screen = SDL_SetVideoMode( SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, SDL_SWSURFACE );						
										Repaint();
								break;
								case	SDLK_ESCAPE:
										Fquit=1;
								break;
								case	SDLK_r:
										Repaint();
								break;							
							}					
				break;
				
				case	SDL_MOUSEBUTTONDOWN:
						mouse_x=event.button.x;
						mouse_y=event.button.y;				
						#ifdef DEBUG 
							printf("Evento Raton Abajo X=%d Y=%d Nboton=%d\n",mouse_x,mouse_y,event.button.button);	
						#endif
						
						if(event.button.button==1) 	 {	Eventos();	 }
						if(event.button.button==2)	 { }
						if(event.button.button==3)	 { }
												
						goto salir12;						
						SDL_Flip( screen );
salir12:
				break;
				
				case	SDL_MOUSEBUTTONUP:
						mouse_x=event.button.x;
						mouse_y=event.button.y;
						Repaint();									
						#ifdef DEBUG 
							printf("Boton Arriba X=%d Y=%d \n",mouse_x,mouse_y);
						#endif	
				break;
				
				case	SDL_QUIT:
					Fquit = 1;
				break;		
			}			
		}
	}
		
//Cerrar todo el SDL
	clean_up();
	#ifdef DEBUG 
		printf("Fin\n");
	#endif	
	SDL_Delay(500);
	return 0;  
}

void Agujas(int x,int y,int gra,int tamano)
{
 float radianes;
 int  Xm, Ym;
	radianes=(gra*3.1416)/180;
	 Xm=tamano*cos(radianes);
	 Ym=tamano*sin(radianes);
	//printf("S=%d Grados=%d  Radianes=%f  sen=%f   cos=%f\n",fecha->tm_sec,gra,radianes,sin(radianes),cos(radianes) );	
	line(x,y,x- Xm,y+ Ym);
}


void Esfera(int x,int y,int tamano)
{
 float radianes;
 int z;
 int  Xm, Ym;
 int  Xn, Yn;
	for(z=0;z<360;z+=30)
		{
		 radianes=(z*3.1416)/180;	
		  Xm=tamano*cos(radianes);
		  Ym=tamano*sin(radianes);
		 
		  Xn=70*cos(radianes);
		  Yn=70*sin(radianes);
		 
		 line(x- Xn,y+ Yn,x- Xm,y+ Ym);
		}
}



void Repaint(void)
{

	//SDL_FillRect( screen, NULL, SDL_MapRGB( screen->format, 0x15, 0xaa, 0x30 ) );
	apply_surface( 0, 0, background, screen );
	
	
	time(&ahora);
	fecha=localtime(&ahora);
	
	sprintf(cadenaTmp,"%02d:%02d:%02d\n",fecha->tm_hour, fecha->tm_min ,fecha->tm_sec);
	setcolor(255,7,7);	PrintTexto(50,1,cadenaTmp,font2);
	
	sprintf(cadenaTmp,"%02d/%02d/%02d\n",fecha->tm_mday, fecha->tm_mon+1 ,fecha->tm_year+1900);   
	setcolor(0,0,200);	PrintTexto(30,45,cadenaTmp,font2);
	
	
	
	gradosS=270-6*fecha->tm_sec;
	gradosM=270-6*fecha->tm_min;
	gradosM-=(fecha->tm_sec*6)/60;
	gradosH=270-30*fecha->tm_hour;
	gradosH-=(fecha->tm_min*30)/60;
	
	//setcolor(0,0,0); Esfera(relojX,relojY,85);
	
	setcolor(0,0,200); Agujas(relojX,relojY,gradosS,80);
	setcolor(255,0,0); Agujas(relojX,relojY,gradosM,70);
	setcolor(0,2,2); Agujas(relojX,relojY,gradosH,50);	


	
	Redibujado();					
	SDL_Flip( screen );
}


//____________________FIN____________

void MiTimer()
{
 tiempo1--;		tiempo2--;		tiempo3--;
 if( tiempo1<0)
     { tiempo1=TIEMPO1;}
 if( tiempo2<0)
     { tiempo2=TIEMPO2;}
 if( tiempo3<0)
     { 
	  tiempo3=TIEMPO3;
	  segundos++;	  
	  Repaint();
	 }
				
}


 
